<template>
	<v-chart ref="echart" :options="chart_options" autoresize></v-chart>
</template>

<script>
	import chart_colors from "../charts/chart_colors";

	export default {
		name: "MemoryChart",
        props: ['free', 'usage', 'total_label'],
		computed: {
			chart_data(){
				return [
					{
						value: this.usage,
						name: 'Usage',
						itemStyle: {
							color: chart_colors.blue_gradient
						}
					},
					{
						value: this.free,
						name: 'free',
						itemStyle: {
							color: chart_colors.green_gradient
						}
					},
				]
			}
		},
		watch: {
			chart_data(data){
				this.chart_options.series[0].data = data;
			},
		},
        data(){
		    return {
				chart_options: {
					series: [
						{
							name: 'chart',
							type: 'pie',
							top: 0,
							left: 0,
							width: '100%',
							height: '100%',
							hoverOffset: 0,
							startAngle: 90,
							clockwise: true,
							radius: ['70%', '100%'],
							center: ['50%', '50%'],
							label: {
								show: false,
								position: 'center',
							},
							emphasis: {
								label: {
									show: true,
									fontSize: 25,
									formatter: (params) => {
										return params.name + '\n' + this.formatBytes(params.value);
									},
								}
							},
							data: this.chart_data
						}
					],
				},
            }
        },
        methods: {
            formatBytes(bytes, decimals = 2) {
                if (bytes === 0) return '0 Bytes';

                const k = 1024;
                const dm = decimals < 0 ? 0 : decimals;
                const sizes = ['Bytes', 'KB', 'MB', 'GB', 'TB', 'PB', 'EB', 'ZB', 'YB'];

                const i = Math.floor(Math.log(bytes) / Math.log(k));

                return parseFloat((bytes / Math.pow(k, i)).toFixed(dm)) + ' ' + sizes[i];
            },
        },
		mounted() {
			this.chart_options.series[0].data = this.chart_data;
		}
	}
</script>

<style scoped>
.echarts{
	width: 250px;
	height: 250px;
	margin: 0 auto;
}
</style>
